<template>
  <div class="fixed top-0 z-30 w-full header">
    <div class="bg-background3 relative z-[60] border-b-2 border-background-4">
      <div v-loading="isLoading" class="header-container relative mx-auto">
        <div class="flex items-center justify-between h-[92px] header-menu">
          <div v-if="logo.IsHidden"></div>
          <div class="flex items-center">
            <div class="flex justify-center items-center" v-if="isPeruShopEnabled">
              <div class="flex justify-start w-40 h-[90px] logo-container">
                <img :src="getAssetImage('assets/common/568win-white-logo.png')" alt="568win-Logo" class="object-contain" />
              </div>
            </div>
            <div class="flex justify-center items-center mx-4" v-if="isPeruShopEnabled">
              <button class="x-logo"></button>
            </div>
            <div class="flex justify-center items-center">
              <nuxt-link v-if="!logo.IsHidden" :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'">
                <div class="flex justify-start w-40 h-[90px] logo-container">
                  <img :src="logo.ImagePath" class="object-contain" />
                </div>
              </nuxt-link>
            </div>
          </div>
          <HambugerMenu />
          <div class="nav-bar">
            <div
              class="flex items-center justify-end mt-3 mb-2.5 gap-4"
              @mouseover="isFeatureContentEnabled = false"
            >
              <div v-if="auth && !isPeruShopEnabled" class="flex items-center">
                <utils-profile-information
                  :referral-enabled="referralEnabled"
                  :username="username"
                  :is-show-deposit-withdrawal="isShowDepositWithdrawal"
                  :is-cash-player="isCashPlayer"
                  :logout="logout"
                  :is-referral-v2-enabled="isReferralV2Enabled"
                />
              </div>
              <div v-if="auth" class="flex items-center">
                <utils-balance-information v-if="!isBalance" :is-suspended="isSuspendedAccount" />
                <nuxt-link to="/">
                  <div class="bg-[#E6A23B] rounded-full flex justify-center items-center h-8 w-8 mx-4" v-if="isPeruShopEnabled">
                    <svg-icon svg-name="icon-home" class="w-[20px] h-[20px]" />
                  </div>
                </nuxt-link>
                <el-button type="success" round @click="showQrCodePopup" v-if="isPeruShopEnabled">
                  {{ $t('Sports Payout') }}
                </el-button>
                <nuxt-link
                  v-if="isCashPlayer && isShowDepositWithdrawal"
                  to="/deposit"
                  class="px-4 py-1 mx-4 rounded-2xl btn --secondary --textBtn"
                >
                  <b>{{ $t(`deposit${isBhinbhin}`) }}</b>
                </nuxt-link>
              </div>
              <div v-else class="flex items-center gap-4">
                <nuxt-link
                  to="/login"
                  class="px-4 py-1 btn rounded-2xl --secondary --textBtn"
                  ><b>{{ $t("log_in") }}</b></nuxt-link
                >
                <nuxt-link
                  v-if="!register.IsHidden"
                  to="/register"
                  class="px-4 py-1 rounded-2xl btn --primary --textBtn"
                  :id="ID.SIGNUP"
                  ><b class="pointer-events-none">{{ $t("joinnow") }}</b></nuxt-link
                >
              </div>
              <nuxt-link
                v-if="!agentCooperation.IsHidden"
                to="/agent-cooperation"
                :class="
                  themeName === 'peru'
                    ? ' px-4 py-1 btn --primary rounded-2xl --textBtn'
                    : 'px-4 py-1 btn --tertiary rounded-2xl --textBtn'
                "
                ><b>{{ $t("agent_cooperation") }}</b></nuxt-link
              >
              <utils-language />
            </div>
            <ul
              class="flex items-center justify-end capitalize whitespace-nowrap"
            >
              <li
                v-if="!isPeruShopEnabled && !homeTab.IsHidden"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="isFeatureContentEnabled = false"
              >
                <nuxt-link
                  class="header-height w-max menu-tab-hover-animated"
                  to="/"
                  :id="ID.TAB_TYPE.HOME"
                  :class="[
                    {
                      'active-menu': tabSelected === '/',
                    },
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  ><b class="pointer-events-none">{{ $t("home") }}</b></nuxt-link
                >
              </li>
              <!-- {{ menuTabHeaders }} -->
              <li
                v-for="tab in menuTabHeaders"
                :key="tab"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="productListFeatureHover(tab.TabType, tab.TabURL)"
              >
                <nuxt-link
                  :to="tab.TabURL"
                  :class="[
                    {
                      'active-menu':
                        tabSelected === tab.TabURL?.toLowerCase() ||
                        testActiveGame(tab.TabType, activeTab),
                    },
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  :id="ID.TAB_TYPE[tab.TabLanguage]"
                  class="header-height w-max menu-tab-hover-animated --text3"
                >
                  <b class="pointer-events-none">{{ $t(tab.TabLanguage) }}</b>
                </nuxt-link>
              </li>
              <li
                v-if="isAllowPromotionTab"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="isFeatureContentEnabled = false"
              >
                <nuxt-link
                  to="/promotion"
                  :class="[
                    { 'active-menu': tabSelected === '/promotion' },
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  :id="ID.TAB_TYPE.PROMOTION"
                  class="header-height w-max menu-tab-hover-animated"
                  ><b class="pointer-events-none">{{ $t("promotion") }}</b></nuxt-link
                >
              </li>
              <li
                v-if="isAppDownloadEnabled"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="isFeatureContentEnabled = false"
              >
                <nuxt-link
                  to="/app-download"
                  :class="{ 'active-menu': tabSelected === '/app-download' }"
                  class="header-height w-max menu-tab-hover-animated"
                  ><b>{{ $t("app_download") }}</b></nuxt-link
                >
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
    <product-feature-tab-hover
      v-model:is-feature-hover="isFeatureContentEnabled"
      :component-key="componentKey"
      :feature-products="filterProductFeature"
    />
    <div
      class="py-2 border-t-2 border-background-4 bg-background1 m-notice announcement-style flex items-center"
      v-if="!(announcement.IsHidden && timeZoneIsHidden)"
    >
      <div
        class="header-container w-full flex items-center mx-auto"
        :class="announcement.IsHidden ? 'justify-end' : ''"
      >
        <utils-announcement
          v-if="!announcement.IsHidden"
          :announcement="announcement.Text"
        />
        <utils-display-time
          v-if="!timeZoneIsHidden"
          class="text-right peru__theme-display-time"
        />
      </div>
    </div>
  </div>
  <div :class="{'lg:h-[92px] h-[56px]': announcement.IsHidden && timeZoneIsHidden, 'lg:h-[128px] h-[88px]': !(announcement.IsHidden && timeZoneIsHidden)}"></div>
  <div class="custom-dialog-ads-elementUI">
    <qr-code-modal :isShowQrCodePopup="isShowQrCodePopup" :PayoutInfo="PayoutInfo" :on-before-close="() => isShowQrCodePopup = false" @closeModal="() => isShowQrCodePopup = false"/>
  </div>
</template>

<script lang="ts">
import HambugerMenu from "@/components/theme/desktop/peru/components/hamburger-menu-peru.client.vue";
import {
handleGameEntryOpenWindow,
useHeaderComponent,
} from "@/composables/useTheme";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import EnumThemePropertyKey from "@/models/enums/enumThemePropertyKey";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import featuresToggleHelper from "@/utils/featuresToggleHelper";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { PropType, computed, defineComponent } from "vue";
import useSportQrCode from "@/composables/useSportQrCode";

export default defineComponent({
  name: "Header",
  components: { HambugerMenu },
  props: {
    propertyKeys: {
      type: Array as PropType<Array<string>>,
      required: true,
    },
  },
  setup(props) {
    const isTest = ref(true);
    const { getAssetImage, isBhinbhin } = commonHelper;
    const { showQrCodePopup, isShowQrCodePopup, PayoutInfo } = useSportQrCode();
    const themeName = store.state.selectedThemeName;
    const isPeruShopEnabled = computed(() => store.state.isPerushopEnabled);
    const timeZoneIsHidden = computed(
      () =>
        featuresToggleHelper.getThemePropertyFromApi(
          EnumThemePropertyKey.HtmlId,
          "time_zone"
        ).IsHidden
    );
    const isBalance = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
      EnumThemePropertyKey.HtmlId,
      "balance").IsHidden
    );
    const {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      isAppDownloadEnabled,
      username,
      logout,
      isCashPlayer,
      isShowDepositWithdrawal,
      componentKey,
      isReferralV2Enabled,
      homeTab,
    } = useHeaderComponent();
    const route = useRoute();
    const activeTab = computed(() => route.query.tab ?? "");
    const testActiveGame = (tabType: string, activeGame: string): boolean => {
      const temTabType = tabType
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      const temActiveGame = activeGame
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      return temActiveGame === temTabType;
    };
    const properties = computed(() => props.propertyKeys);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );

    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[0]
        )
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[1]
        )
    );
    const isVietnamLangBlackTheme = computed(
      () =>
        store.state.locale === "vi_VN" &&
        store.state.selectedThemeName === "black"
    );
    return {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      announcement,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      activeTab,
      testActiveGame,
      logo,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      isAppDownloadEnabled,
      getAssetImage,
      isShowDepositWithdrawal,
      isCashPlayer,
      username,
      logout,
      componentKey,
      isVietnamLangBlackTheme,
      store,
      themeName,
      timeZoneIsHidden,
      isBalance,
      isReferralV2Enabled,
      showQrCodePopup,
      isShowQrCodePopup,
      PayoutInfo,
      isPeruShopEnabled,
      isTest,
      homeTab,
      isBhinbhin,
    };
  },
});
</script>
<style lang="scss" scoped>
.bg-header {
  background-color: var(--background3);
}
.header-height {
  height: 40px;
  display: flex;
  align-items: center;
  position: relative;
}
.nav-item .active-menu,
.nav-item:hover .header-height {
  color: var(--selected);
}
.nav-item .active-menu::before,
.nav-item:hover .header-height::before {
  background-color: var(--selected);
  bottom: 0;
  content: "";
  height: 0.125rem;
  left: 0;
  position: absolute;
  width: 100%;
}
.m-notice {
  height: 36px;
}

@media screen and (max-width: 1023px) {
  .nav-bar {
    display: none;
  }
  .header-menu {
    height: 52px;
    .logo-container {
      width: 60px;
      height: 30px;
    }
  }
  .m-notice {
    height: 32px;
  }
}
@media screen and (min-width: 1024px) and (max-width: 1280px) {
  .nav-bar {
    font-size: 14px;
  }
  announcement-style {
    padding-left: 40px;
    padding-right: 40px;
  }
}
.dropdown-list-menu::after {
  border-color: white;
}
@media screen and (min-width: 1280px) and (max-width: 1536px) {
  .announcement-style {
    padding-left: 40px;
    padding-right: 40px;
  }
}
@media screen and (min-width: 1537px) {
  .announcement-style {
    padding-left: 168px;
    padding-right: 168px;
  }
}

</style>
